%invoke wia.pub.pkgdepend.ui.about:getMetadata%
   <html>
      <head>
         <meta http-equiv="pragma"        content="no-cache">
         <meta http-equiv="content-type"  content="text/html; charset=utf-8">
         <title>Wrightia :: wM Package Dependencies</title>
         %invoke wia.pub.pkgdepend.ui.util:getStyleMetadata%
         <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
         <link rel="stylesheet" type="text/css" href="/WiaRoot/css/onlinedoc.css">
         %end invoke%
         <title>Wrightia :: wM Package Dependencies</title>
         <style>
            body { border: none; }
            .wip, .warning
               {
               color: red;
               font-style: italic;
               }
            hi, h3 { width: auto; }
            div.bodyText
               {
               margin-right: 30px;
               }
            li {
               margin-top: 1em;
               }
            li img
               {
               vertical-align: middle;
               margin: -2px -4px;
               }
            li p
               {
               margin-left: 0;
               margin-top:  .2em;
               margin-bottom:  .3em;
               }
            .emphasized
               {
               font-weight: bold;
               font-style: normal;
               }
         </style>
      </head>

      <body>
         <table width="100%" border="0">
            <tr>
               <td>
                  <h1 class="title">%value packageLongName%, v%value packageVersion%</h1>
                  <h3 class="title">Home Page</h3>
               </td>
               <td width="10" align="right">
                  <img src="/WiaRoot/images/logo.gif">
               </td>
            </tr>
         </table>
         <br/><br/>

         <h2>Credits</h2>
            <div class="bodyText">
               <p>A tool package developed by <span class="productname">Wrightia, S.A.</span> &copy; 2008.</p>
            </div>

      %ifvar LicenseInfo/isValid equals('false')%
         <h2>License Warning</h2>
            <div class="bodyText">
               <p class="warning">
                  This is installation is not in an usable state due to licensing restrictions.
               </p>
               <p class="warning">
                  Please check your Service Profiler instalation: it does not need to be started, <span class="emphasized">but it has to be valid</span>.
               </p>
            </div>
      %end if%

       <h2>Purpose</h2>
         <div class="bodyText">
            <p>
               This package serves the purpose of extending the <span class="productname">webMethods Admin Page</span>
               package management functionality.
            </p>
            <p>
               It implements a tool for
            %ifvar LicenseInfo/isValid equals('false')%
               <span class="productname">analysis &amp; report of package dependencies</span>.
            %else%
               %invoke wia.pub.pkgdepend.ui.homepage:getMetadata%%ifvar hasRemoteAliases equals('true')%<a href="SelectServer.dsp">%else%<a href="AnalyzeDependencies.dsp">%endif%%onerror%<a href="AnalyzeDependencies.dsp">%endinvoke%analysis &amp; report of package dependencies</a>.
            %end if%
            </p>
            <p>
               The <span class="productname">analysis &amp; report of package dependencies</span> tool does more than
               just report the dependencies. It:
            </p>
            <ul>
               <li>Discriminates dependencies that are defined by <span class="emphasized">design</span>, from those only detectable in <span class="emphasized">runtime</span>;
                  <p>
                     To have runtime dependencies analyzed, it is required to have the <span class="productname">Service Profiler</span>
                     installed, and either running or with a snapshot loaded.
                  </p>
                  <p>
                     <span class="systemname">Design-time</span> <tt>(D)</tt> dependencies are those that are not declared in the
                     package definition, but that can be determined by directly evaluating the references between the nodes.
                  </p>
                  <p>
                     <span class="systemname">Runtime</span> <tt>(R)</tt> are those that are not declared in the package definition,
                     could not be determined by directly evaluating the references between the nodes, but were detected by
                     analyzing the runtime data provided by the <span class="productname">Service Profiler</span>.
                  </p>
               </li>
               <li>Identifies <span class="systemname">Circular References</span>;
                  <p>
                     Circular references have their reference path represented and are also discriminated by its type:
                  </p>
                  <ul>
                     <li><span class="systemname">Declared</span> <tt>(CD)</tt>;
                        <p>
                           Circular reference caused by dependencies declared in the package definition.
                        </p>
                        <p>
                           These are the kind that the <span class="productname">Integration Server</span> evaluates at startup and that can make package loading fail.
                        </p>
                     </li>
                     <li>By reference in <span class="systemname">Design-time</span> <tt>(CRD)</tt>;
                        <p>
                           Circular reference caused by dependencies determined by directly evaluating the references
                           between the nodes.
                        </p>
                     </li>
                     <li>By reference in <span class="systemname">Runtime</span> <tt>(CRR)</tt>.
                        <p>
                           Circular reference caused by dependencies determined by analyzing the runtime data provided by
                           the <span class="productname">Service Profiler</span>.
                        </p>
                     </li>
                  </ul>
               </li>
               <li>Identifies dependencies from <span class="productname">Adapter Packages</span> <tt>(A)</tt>;
                  <p>The dependency from the <span class="productname">Adapter Packages</span> is mandatory when the source
                     package contains <span class="productname">Adapter Connections</span>.
                  </p>
                  <p>The identification of the <span class="productname">Adapter Package</span> is not trivial and not
                     readilly available from the platform. This tool uses a documentation feature of the
                     <span class="productname">ADK</span> to deduce which is <span class="productname">Adapter Package</span> to refer to.
                     However, if the adapter implementation does not use that feature, it is not possible to establish the
                     relation. All known commercial adapters use the feature. Only one custom built and ill-behaved
                     adapter was so far identified which skips the use of that documentation feature.
                  </p>
                  <p>A package that depends on an <span class="productname">Adapter Package</span> is signaled with a
                     detached <tt>A</tt> in the header of its analysis header and to the right of the dependent package name.
                  </p>
               </li>
               <li>Identifies references to <span class="systemname">Undefined Nodes</span> <tt>(U)</tt>;
                  <p>
                     These references also identify the node that makes the reference, so it can be easily analyzed.
                  </p>
                  <p>
                     These undefined references can be one of:
                  </p>
                  <ul>
                     <li>A node that is defined in a <span class="emphasized">disabled</span> package;</li>
                     <li>A node that was <span class="emphasized">deleted</span>;</li>
                     <li>A Node that does not yet exist, or exists in a <span class="emphasized">package not yet installed</span>;
                     <li>A Node that is part of a <span class="emphasized">deprecated package</span>;
                        <p><i>i.e</i>; uninstalled.</p>
                     <li>etc.</li>
                  </ul>
               </li>
               <li>Identifies dependencies declared in excess <tt>(X)</tt>;
                  <p class="warning">
                     Use this feature with caution.
                  </p>
                  <p>
                     Some dependencies may be explicitly declared for use of references that are not analyzed by the tool,
                     for instance:
                  </p>
                  <ul>
                     <li><span class="productname">CSS</span> files;</li>
                     <li><span class="productname">JavaScript</span> files;</li>
                     <li>Image files.</li>
                  </ul>
                  <p>However, this feature is still useful because, if you do not exactly know why it exists, it raises
                     the suspicion and makes you investigate, because declared packages that are not needed may force
                     the installation of a chain of packages that are doing nothing but still consuming server resources.
                  </p>
               </li>
               <li>Allows declaring packages dependencies;
                  <p class="warning">
                     Use this feature with caution.
                  </p>
                  <p>
                     Even though the tool tries to anticipate potential circular
                     references, not all situations may be accounted for and some allowed settings may themselves
                     generate circular references, and the affected packages may not reload.
                     If this situation becomes a reality, the only solution is to edit the package manifest file
                     directly in the file system (<em>to remove the offending dependencies</em>) and reload the package.
                     In some cases, you will have no choice but to edit the package using either <span class="productname">
                     Developer</span> or <span class="productname">Designer</span>.
                  </p>
                  <p>
                     The found not-declared dependencies are editable and presented using text-boxes and checkboxes.
                  </p>
                  <p>
                     The checked ones are added to the declared dependencies of the package when the <tt>save changes</tt> button is pressed.
                     This also triggers the re-analysis of the dependencies and re-generation of the report.
                  </p>
               </li>
               <li>Identifies packages that are <span class="productname">Adapter</span>s and dependencies from <span class="productname">Adapter Types</span> that are not installed/enabled.
                  <p>
                     This is a very important feature, because any package that contains an <span class="productname">Adapter Connection</span>,
                     <span class="productname">Adapter Service</span>, <span class="productname">Adapter Listener</span> or
                     <span class="productname">Adapter Notification</span> <span class="stressed">must</span>
                     explicitly declare a dependency from the package of the adapter (<span class="warning">this is also a recommendation from the platform manufacturer</span>). If you fail to do so, instability may be
                     created when installing patches, new versions of the adapter or otherwise reloading the adapter package.
                  </p>
                  <p>
                     To overcome deployment issues, the <span class="productname">Adapter Connection</span> nodes are usually packaged separate from
                     the <span class="productname">Adapter Service</span> nodes that refer to them. On this case, it is not mandatory to have
                     the services package have a direct dependency from the adapter package: it can depend on the connection's package and this
                     one have the dependency on the adapter's.
                  </p>
                  <p>
                     Identification of the package of an adapter by dependency checking is not available <em>out-of-the-box</em> nor is it trivial.
                     Hence, the identification may fail even if the package exists. Nevertheless, a reference to an undefined node will be reported.
                  </p>
               </li>
               <li>Allows making the dependencies analysis on a remote <span class="productname">Integration Server</span>.
                  <p>
                     However, a version of the <span class="productname">Package Dependencies Analyzer</span> does need to exist installed
                     and enabled at the remote server(s).
                  </p>
                  <p>
                     To enable this feature, all you have to do is to create on this <span class="productname">Integration Server</span>
                     the <span class="productname">Remote Aliases</span> named as <tt>*%value RemoteAliasSuffix%</tt>.
                     Those are then listed in a selection page, where you can select one of them to execute the dependencies
                     analysis onto, remotely.
                  </p>
               </li>
            </ul>
         </div>
       <h2>Known Limitations</h2>
         <div class="bodyText">
            <p>
               Even though this tool is already in a quite usable state, there are known situations that it does not handle:
            </p>
            <ul>
               <li>Dependencies generated in <span class="productname">DSP</span>s or <span class="productname">Service Output Template</span>s are not being fully analyzed;
                  <p>
                     Dependencies on service invocations in <span class="productname">DSP</span>s are already being analyzed and reported.
                  </p>
                  <p>
                     The dependencies that are <span class="stressed">not</span> being analyzed are those caused by referencing page resources
                     at other packages, such as: images, <span class="productname">javascript</span> or <span class="productname">CSS</span>, page includes, etc.
                  </p>
               </li>
            </ul>
         </div>
         <br/><br/>
      </body>
   </html>
%onerror%
   <html>
      <head>
         <title>Access Denied</title>
      </head>
     <body>
         Access Denied.
         <br/>
         <br/>
         Services necessary to show this page are currently unavailable on this
         port.  This is most likely due to port security restrictions.
         <br/>
         <br/>
         If this is the only port available to access the B2B Server, contact webMethods Support.
      </body>
   </html>
%endinvoke%
